[Starting Out](https://learnyousomeerlang.com/starting-out#the-shell)

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="keywords" content="Erlang, Shell, commands, code, VM, werl, erl, eshell" />
		<meta name="description" content="The Erlang shell (Eshell), its basic commands, how to get around in it. How to kill, start, connect to processes." />
        <meta name="google-site-verification" content="mi1UCmFD_2pMLt2jsYHzi_0b6Go9xja8TGllOSoQPVU" />
		<link rel="stylesheet" type="text/css" href="https://learnyousomeerlang.com/static/css/screen.css?v3" media="screen" />
		<link rel="stylesheet" type="text/css" href="https://learnyousomeerlang.com/static/css/sh/shCore.css" media="screen" />
		<link rel="stylesheet" type="text/css" href="https://learnyousomeerlang.com/static/css/sh/shThemeLYSE2.css" media="screen" />
		<link rel="stylesheet" type="text/css" href="https://learnyousomeerlang.com/static/css/print.css" media="print" />
		<link href="https://learnyousomeerlang.com/rss" type="application/rss+xml" rel="alternate" title="LYSE news" />
		<link rel="icon" type="image/png" href="https://learnyousomeerlang.com/favicon.ico" />
		<link rel="apple-touch-icon" href="https://learnyousomeerlang.com/static/img/touch-icon-iphone.png" />
		<link rel="apple-touch-icon" sizes="72x72" href="https://learnyousomeerlang.com/static/img/touch-icon-ipad.png" />
		<link rel="apple-touch-icon" sizes="114x114" href="https://learnyousomeerlang.com/static/img/touch-icon-iphone4.png" />
		<title>Starting Out | Learn You Some Erlang for Great Good!</title>
	</head>
	<body>
		<div id="wrapper">
			<div id="header">
				<h1>Learn you some Erlang</h1>
				<span>for great good!</span>
			</div> <!-- header -->
			<div id="menu">
				<ul>
					<li><a href="https://learnyousomeerlang.com/content" title="Home">Home</a></li>
					<li><a href="https://learnyousomeerlang.com/faq" title="Frequently Asked Questions">FAQ</a></li>
					<li><a href="https://learnyousomeerlang.com/rss" title="Latest News">RSS</a></li>
					<li><a href="https://learnyousomeerlang.com/static/erlang/learn-you-some-erlang.zip" title="Source Code">Code</a></li>
				</ul>
			</div><!-- menu -->
			<div id="content">
            <div class="noscript"><noscript>Hey there, it appears your Javascript is disabled. That's fine, the site works without it. However, you might prefer reading it with syntax highlighting, which requires Javascript!</noscript></div>
<h2>Starting Out</h2>

<h3><a class="local" name="the-shell">The Shell</a></h3>

<p>In Erlang, you can test most of your stuff in an emulator; it will run your scripts when compiled and deployed, but it will also let you edit stuff live. To start the shell in Linux, open a terminal and then type in <code>$ erl</code>. If you've set up everything fine, you should see text like this:</p>
<pre class="brush:eshell">
Erlang R13B01 (erts-5.7.2) [source] [smp:2:2] [rq:2] [async-threads:0] [hipe] [kernel-poll:false]

Eshell V5.7.2  (abort with ^G)
</pre>
<p>Congratulations, you're running the Erlang shell!</p>

<p>For Windows users, you can still run the <code>erl.exe</code> shell, but it's recommended you instead use <code>werl.exe</code>, which can be found in your start menu (<code>programs &gt; Erlang</code>). Werl is a windows-only implementation of the Erlang shell, having its own window with scrollbars and supporting command-line editing (like copy-pasting, which got to be a pain with the standard <code>cmd.exe</code> shell in Windows). The erl shell is still required if you want to redirect standard input or output, or use pipelines.</p>

<p>We'll be able to enter and run code in the emulator, but first, let's see how we can get around in it.</p>


<h3><a class="local" name="shell-commands">Shell Commands</a></h3>
<p>The Erlang shell has a built-in line editor based on a subset of Emacs, a popular text editor that's been in use since the 70s. If you know Emacs, you should be fine. For the others, you'll do fine anyway.</p>

<img class="right" src="https://learnyousomeerlang.com/static/img/shell.png" width="312" height="143" alt="super turtle" title="In your face, Hare!" />

<p>First of all, if you type some text and then go <code>^A</code> (Ctrl+A), you should see your cursor moving to the beginning of the line. <code>^E</code> (Ctrl+E) gets you to the end. You can use arrow keys to go forward, backwards, show previous or next lines so you can repeat code.</p>
<p>If you type something like <code>li</code> and then press "tab", the shell will have completed the terms for you to <code>lists:</code>. Press tab again, and the shell will suggest you many functions to use after. This is Erlang completing the module <code>lists</code> and then suggesting functions from it. You may find the notation weird, but don't worry, you'll get familiar with it soon enough.</p>

<p>I think we've seen enough of shell functionality to be alright, except for one thing: we don't know how to leave! There's a fast way to find how. Just type in <code>help().</code> and you should get information on a bunch of commands you can use in the shell (do not forget the full stop (<code>.</code>) as it is necessary for the command to run). We'll use some of them at a later point, but the only line of concern to us in order to get out is<br />
<code>q()        -- quit - shorthand for init:stop()</code><br />
So this is one way to do it (in fact, two ways). But this won't help us if the shell freezes! If you were paying attention, when you started the shell, there was a comment about 'aborting with <code>^G</code>'. Let's do that, and then press <code>h</code> to get help!</p>
<pre class="brush:eshell">
User switch command
 --&gt; h
  c [nn]            - connect to job
  i [nn]            - interrupt job
  k [nn]            - kill job
  j                 - list all jobs
  s [shell]         - start local shell
  r [node [shell]]  - start remote shell
  q        - quit erlang
  ? | h             - this message
 --&gt;
</pre>

<p>If you type in <code>i</code> then <code>c</code>, Erlang should stop the currently running code and bring you back to a responsive shell. <code>j</code> will give you a list of processes running (a star after a number indicates this is the job you are currently running), which you can then interrupt with <code>i</code> followed by the number. If you use <code>k</code>, you will kill the shell as it is instead of just interrupting it. Press <code>s</code> to start a new one.</p>

<pre class="brush:eshell">
 Eshell V5.7.2  (abort with ^G)
1&gt; "OH NO THIS SHELL IS UNRESPONSIVE!!! *hits ctrl+G*"
User switch command
 --&gt; k
 --&gt; c
Unknown job
 --&gt; s
 --&gt; j
   2* {shell,start,[]}
 --&gt; c 2
Eshell V5.7.2  (abort with ^G)
1&gt; "YESS!"
</pre>
<p>If you read back the help text, you'll notice we can start remote shells. I won't get into details right now, but this should give you an idea of what the Erlang VM can do apart from running code. For now, let's get things started (for real).</p>
				<ul class="navigation">
											<li><a href="https://learnyousomeerlang.com/introduction" title="Previous chapter">&lt; Previous</a></li>
										
					<li><a href="https://learnyousomeerlang.com/contents" title="Index">Index</a></li>
					
											<li><a href="https://learnyousomeerlang.com/starting-out-for-real" title="Next chapter">Next &gt;</a></li>
									</ul>
			</div><!-- content -->
			<div id="footer">
				<a href="http://creativecommons.org/licenses/by-nc-nd/3.0/" title="Creative Commons License Details"><img src="https://learnyousomeerlang.com/static/img/cc.png" width="88" height="31" alt="Creative Commons Attribution Non-Commercial No Derivative License" /></a>
				<p>Except where otherwise noted, content on this site is licensed under a Creative Commons Attribution Non-Commercial No Derivative License</p>
			</div> <!-- footer -->
		</div> <!-- wrapper -->
		<div id="grass" />
	<script type="text/javascript" src="https://learnyousomeerlang.com/static/js/shCore.js"></script>
	<script type="text/javascript" src="https://learnyousomeerlang.com/static/js/shBrushErlang2.js?11"></script>
	<script type="text/javascript">
		SyntaxHighlighter.defaults.gutter = false;
		SyntaxHighlighter.all();
	</script>
	</body>
</html>


